ACM-ICPC 2018 南京赛区网络预赛 E题

 

ACM-ICPC 2018 南京赛区网络预赛 E题

题目连接: https://nanti.jisuanke.com/t/30994c++

Dlsj is competing in a contest with n (0 < n \le 20)n(0<n≤20) problems. And he knows the answer of all of these problems.git

However, he can submit ii-th problem if and only if he has submitted (and passed, of course) s_isi problems, the p{i, 1}pi,1-th, p{i, 2}pi,2-th, ......, p{i, s_i}pi,si-th problem before.(0 < p{i, j} \le n,0 < j \le s_i,0 < i \le n)(0<pi,j≤n,0<j≤si,0<i≤n)After the submit of a problem, he has to wait for one minute, or cooling down time to submit another problem. As soon as the cooling down phase ended, he will submit his solution (and get "Accepted" of course) for the next problem he selected to solve or he will say that the contest is too easy and leave the arena.github

"I wonder if I can leave the contest arena when the problems are too easy for me.""No problem."—— CCF NOI Problem set网络

If he submits and passes the ii-th problem on tt-th minute(or the tt-th problem he solve is problem ii), he can get t \times a_i + b_it×ai+bi points. (|a_i|, |b_i| \le 10^9)(∣ai∣,∣bi∣≤109).spa

Your task is to calculate the maximum number of points he can get in the contest.blog

Input

The first line of input contains an integer, nn, which is the number of problems.ip

Then follows nn lines, the ii-th line contains s_i + 3si+3 integers, a_i,b_i,s_i,p_1,p_2,...,p_{s_i}ai,bi,si,p1,p2,...,psias described in the description above.get

Output

Output one line with one integer, the maximum number of points he can get in the contest.input

Hint

In the first sample.string

On the first minute, Dlsj submitted the first problem, and get 1 \times 5 + 6 = 111×5+6=11 points.

On the second minute, Dlsj submitted the second problem, and get 2 \times 4 + 5 = 132×4+5=13points.

On the third minute, Dlsj submitted the third problem, and get 3 \times 3 + 4 = 133×3+4=13 points.

On the forth minute, Dlsj submitted the forth problem, and get 4 \times 2 + 3 = 114×2+3=11 points.

On the fifth minute, Dlsj submitted the fifth problem, and get 5 \times 1 + 2 = 75×1+2=7 points.

So he can get 11+13+13+11+7=5511+13+13+11+7=55points in total.

In the second sample, you should note that he doesn't have to solve all the problems.

样例输入1复制

5
5 6 0
4 5 1 1
3 4 1 2
2 3 1 3
1 2 1 4

样例输出1复制

55

样例输入2复制

1
-100 0 0

样例输出2复制

0

题目来源

ACM-ICPC 2018 南京赛区网络预赛

 

看到了n<20, 很显然就是要状态压缩了。

而后那个前提条件,其实就是状态转移时候的条件了,只要判断一下就能够了。

 

状态压缩就是用一个二进制数来表示当前的状态,这个数须要有n个二进制位,若是为0表示没有submit这个题,1表示submit了。

dp[i]表示到状态i得到的最多points. 根据i有多少1就知道如今的时间了(每分钟submit一个)。

 

具体看代码吧。


 

#include <bits/stdc++.h>
using namespace std;
​
​
int bit[22];
​
int a[22];
int b[22];
int state[22];
​
long long dp[1<<20];
int numbit[1<<20];
const long long INF = 1000000000000000LL;
​
int main() {
  bit[0] = 1;
  for (int i = 1; i < 22; i++)
    bit[i] = bit[i-1]<<1;
  numbit[0] = 0;
  for (int i = 1; i < bit[20]; i++) {
    numbit[i] = 1 + numbit[i&(i-1)];
  }
  int n;
  while(scanf("%d", &n) == 1) {
    for (int i = 0; i < n; i++) {
      scanf("%d%d", &a[i], &b[i]);
      int s;
      scanf("%d", &s);
      int tmp = 0;
      state[i] = 0;
      while (s--) {
        scanf("%d", &tmp);
        state[i] |= bit[tmp-1];
      }
    }
      dp[0] = 0;
      for (int i = 1; i < bit[n]; i++)dp[i] = -INF;
      long long ans = 0;
      for (int i = 0; i < bit[n]; i++) {
        if (dp[i] == -INF)continue;
        ans = max(ans, dp[i]);
        for (int j = 0; j < n; j++) {
          if (i & bit[j])continue;
          if ((i&state[j]) != state[j])continue;
          dp[i|bit[j]] = max(dp[i|bit[j]], dp[i] + (long long)(numbit[i]+1)*a[j] + b[j]);
        }
      }
      cout<<ans<<endl;
​
  }
  return 0;
}

  

 

 https://kuangbin.github.io/2018/09/01/2018-ACM-ICPC-Nanjing-online-E/

相关文章
相关标签/搜索